/**
The DDP Icograda poster App a project 
by Cristina Chiappini Design Studio
for DDP Dongdaemun Design Park. 

Please send your PDF poster to this email 
for enter in the data base 
of the DDP Icograda poster App:
chiappini.cristina@gmail.com

Change the words in the file: change_words.txt
inside data folder. 

More information:
http://cristinachiappini.com/2013/12/ddp-poster-project/

Development team of the Poster App:
Art direction by Cristina Chiappini
Developed with Processing http://processing.org/
triangulation taken from http://wiki.processing.org/w/Triangulation author Tom Carden, Nicolas Clavaud
WebCam triangulation by Giordano Ricciardi (2012),
Final development of DDP poster App engine by Matteo Stocco (2014)

A first version of the Poster App concept the has been developed 
for the MAXXI National Museum of XXI Century Arts in Rome 
in the Laboratory of the Academy of Fine Arts in Rome 
with the art direction of Cristina Chiappini 
and with the students: Valeria Bocci, Andrea Di Bari, 
Matteo Di Vito and Giordano Ricciardi
*/

import processing.pdf.*;
import processing.video.*;
import org.processing.wiki.triangulate.*;

Capture webcam;
 int gray=210;
PFont font;
PImage Qrcode;
int changeWordsRects= 0;
float dimLinee=1;


int maxGrid = 200;
int soglia = 64;
int gapH = 8;

int strokeColor = 0;
int gapV =5;
int diametro = 200;
int dimPallini = 10; 

color fgColRed = color(0);
color fgColGreen = color(0);
color fgColBlu = color(0);
color pointFgColRed = color(0);
color pointFgColGreen = color(0);
color pointFgColBlu = color(0);
int alphaStroke = 200;
int pointAlpha=1;
int alphaStep=3;
int wordCount=0;


color bgCol = color(255);
color mainCol = color(102, 204, 204);
color tempCol;

String[] parole;
int[] numbers = { 919,893, 867,841,815,789  }; 

int black = 0;
int white=255;

String rand;
float varDia;

ArrayList pVec = new ArrayList();
ArrayList triangles = new ArrayList();

boolean recordGo= false;
boolean render = true;
boolean record;
String fileName;
int clickCount =0;




void setup() {



  size(640, 900);
  smooth();

  webcam = new Capture(this, 640, 480);

  webcam.start();
  Qrcode= loadImage("code.jpg");



  parole = loadStrings("change_words.txt");
}



void draw() {




  if (webcam.available() == true) {
    webcam.read();
    set(0, 0, webcam);
  }
if (mouseX>45 && mouseX<111 ){
   if(mousePressed==true){

  beginRecord(PDF, "DDPposter"+ "#"+clickCount + ".pdf");
  fileName = "DDPposter"+ frameCount;
   }else{black=0;white=255;}
  }
  

  if (frameCount > 90 && render) { 



    for (int i = 0; i < maxGrid; i++) {
      for (int j = 0; j < maxGrid; j++) {




        if (j%2 == 0) { 
          tempCol = (int)brightness(get(i*gapH, j*gapV));   } 
        else 
        { 
 tempCol = (int)brightness(get(i*gapH+gapH/2, j*gapV));
        }

        if (tempCol < soglia && j*gapV<430 && i*gapH <width) {
          if (j%2 == 0) { 
            pVec.add(new PVector(i*gapH+gapH/2, j*gapV, brightness(tempCol)));
          }
          else {
                pVec.add(new PVector(i*gapH+gapH/2, j*gapV, brightness(tempCol)));
          }
        }
      }
    }

    if (pVec.size() > 2) { 
      triangles = Triangulate.triangulate(pVec);
    }




    background(255);




    pushStyle();
    stroke(fgColRed, fgColGreen, fgColBlu, 30);
    strokeWeight(dimLinee);


    noFill();
    smooth();
    strokeCap(ROUND);
    strokeJoin(ROUND);
    beginShape(TRIANGLES);
   
    for (int i = 0; i < triangles.size(); i++) {
      Triangle t = (Triangle)triangles.get(i);
      vertex(t.p1.x, t.p1.y);
      vertex(t.p2.x, t.p2.y);
      vertex(t.p3.x, t.p3.y);
    }
    endShape();
    popStyle();
    pushStyle();



    
    stroke(pointFgColRed, pointFgColGreen, pointFgColBlu, pointAlpha); 
    for (int i = 0; i < pVec.size(); i++) {
      PVector p = (PVector)pVec.get(i);

      varDia = map(p.z, 0, 255, dimPallini, 0);
      strokeWeight(varDia);
      point(p.x, p.y);
    }
    popStyle();


    pVec.clear();
    triangles.clear();
    render = true;
  }



  ///////////////////////////////////////////////User Gui


  pushMatrix();
  translate(0, -100); 
  font= createFont("Helvetica-Bold", 100);
  textFont(font);
  noStroke();

int step= round(map(dimLinee,1,26,0,5));
int step2= round(map(soglia,20,264,0,5));
int step3= round(map(dimPallini,2,42,0,5));
int step4= round(map(pointAlpha,0,200,0,5));


  fill(100, 100, 100);
 

  fill(0);
  textSize(60);
  



  text(parole[wordCount], 40, 650);




  text("DDP", 40, 710);

  textSize(10);
fill(100);
 
  pushMatrix();                  
 pushMatrix();                    

  translate(-340, 914);
  rotate(radians(-90));
  fill(100);
  text("LINES DIMENSIONS", -31, 765);
 
 for(int h =0; h<150; h=h+26){
  
   fill(200,200,200);
  rect(-30+h,768,25,8); 
  
    
 }
  
popMatrix();



fill(50);
rect(428,numbers[step],8,25);
if(step>0){
rect(428,numbers[0],8,25);
if (step>1){
rect(428,numbers[1],8,25);
if(step>2){
rect(428,numbers[2],8,25);
if (step>3){
rect(428,numbers[3],8,25);
if (step>4){
rect(428,numbers[4],8,25);

}
}
}
}
}
  




fill(100);

  pushMatrix();
 translate(-304, 901);
  rotate(radians(-90));

  text("LINES QUANTITY", -45, 765); 
  
   for(int h =0; h<150; h=h+26){
  
   fill(200,200,200);
  rect(-43+h,768,25,8); 
   
 }
 
 
popMatrix();




fill(50);
rect(464,numbers[step2],8,25);
if(step2>0){
rect(464,numbers[0],8,25);
if (step2>1){
rect(464,numbers[1],8,25);
if(step2>2){
rect(464,numbers[2],8,25);
if (step2>3){
rect(464,numbers[3],8,25);
if (step2>4){
rect(464,numbers[4],8,25);

}
}
}
}
}
 fill(100);
  



  


  pushMatrix();

  translate(-192, 911);
  rotate(radians(-90));
 
  text("DOTS DIMENSIONS", -34, 725); 
    for(int h =0; h<150; h=h+26){
  
   fill(200,200,200);
  rect(-33+h,728,25,8); 
   
 }
 
 
  
  
  
popMatrix();




fill(50);
rect(536,numbers[step3],8,25);
if(step3>0){
rect(536,numbers[0],8,25);
if (step3>1){
rect(536,numbers[1],8,25);
if(step3>2){
rect(536,numbers[2],8,25);
if (step3>3){
rect(536,numbers[3],8,25);
if (step3>4){
rect(536,numbers[4],8,25);

}
}
}
}
}
fill(100);
 
 
  

   pushMatrix();

  translate(-348, 931);
  rotate(radians(-90));
  text("DOTS TRANSPARENCY", -14, 845); 
   for(int h =0; h<150; h=h+26){
  
   fill(200,200,200);
  rect(-13+h,848,25,8); 
 
 }
 
 
 

popMatrix();

pointAlpha=round(map(alphaStep,0,6,0,200));





fill(50);
rect(500,numbers[step4],8,25);
if(step4>0){
rect(500,numbers[0],8,25);
if (step4>1){
rect(500,numbers[1],8,25);
if(step4>2){
rect(500,numbers[2],8,25);
if (step4>3){
rect(500,numbers[3],8,25);
if (step4>4){
rect(500,numbers[4],8,25);

}
}
}
}
}
 fill(100);


  fill(100);
  

  textSize(10);

  pushMatrix();

  translate(-275, 905);
  rotate(radians(-90));
 
  text("CHANGE WORDS", -40, 845);
 popMatrix();



 fill(gray);
rect(width-63, 925, 18, 18);

if(mouseX>577 && mouseX<634 && mouseY>828 && mouseY<845 && mousePressed==true){
       
       
         gray=0;}
         
        else{gray=210;}






  image(Qrcode, 83, 902, 45, 45);
  textSize(10);
  smooth();
  fill(100, 100, 100);
  
  
 
  
  

  
   pushMatrix();
  translate(-869, 1433);
  rotate(radians(-90));
  textSize(3);
  text("POSTER DESIGN BY CRISTINA CHIAPPINI STUDIO", width-154, 880); 
   popMatrix();
    pushStyle();
    
    
  pushMatrix();
  translate(-829, 1340);
  textAlign(RIGHT);
  rotate(radians(-90));
textSize(10);
  text("DOWNLOAD APP", width-164, 880);
  text("AND DESIGN", width-184, 890);
  text("YOUR DDP POSTER", width-150, 900);
  popMatrix();
  popStyle();

 textSize(10);
  pushMatrix();

  translate(-389, 890);
  rotate(radians(-90));
  text("LINES COLORS", -55, 775); 

  popMatrix();
 
 
  pushMatrix();

  translate(width+409, 764);
  rotate(radians(90));


 


  fill(75, 247, 139 );
  rect(25, 650, 25, 8);

  

  fill(148, 115, 255);
  rect(51, 650, 25, 8);


  
  fill(255, 38, 150);
  rect(77, 650, 25, 8);
  
  fill(0, 0, 255);
  rect(103, 650, 25, 8);

  
  fill(255, 0, 0);
  rect(129, 650, 25, 8);

  fill(0); 
  rect(155, 650, 25, 8);




  popMatrix();

 pushMatrix();
fill(100);
  translate(-416, 890);
  rotate(radians(-90));
  text("DOTS COLORS", -55, 765);
  popMatrix();  

 




  pushMatrix();

  translate(width+459, 787);
  rotate(radians(90));


  

  fill(75, 247, 139);
  ellipse(25, 740, 12, 12);

  

  fill(148, 115, 255 );
  ellipse(50, 740, 12, 12);



  
  fill(255, 38, 150);
  ellipse(75, 740, 12, 12);
 
  fill(0, 0, 255);
  ellipse(100, 740, 12, 12);

 
  fill(255, 0, 0);
  ellipse(125, 740, 12, 12);
  
  fill(0); 
  ellipse(150, 740, 12, 12);
  popMatrix();


  popMatrix();

popMatrix();
  endRecord(); 

  frame.setTitle("DDP poster");

  pushStyle();
    textSize(16);
   
    smooth();
     fill(black);
    rect(45,689,66,20);
   fill(white);
    text("PRINT", 52.5, 705);
    
 popStyle();



}


void mousePressed(){
  
  
  //dots colors
  
  if (  mouseX>355 && mouseX<364 && mouseY>705 && mouseY<719) {




   

      pointFgColRed =75;
      pointFgColGreen =247;
      pointFgColBlu =139;
    
  }
  else {
  }

if (  mouseX>355 && mouseX<364 && mouseY>735 && mouseY<741) {





      pointFgColRed =148;
      pointFgColGreen =115;
      pointFgColBlu =255;
    
  }
  else {
  }

 if (  mouseX>355 && mouseX<364 && mouseY>758 && mouseY<770) {



    

     
        pointFgColRed =255;
      pointFgColGreen =38;
      pointFgColBlu =150;
    
  }
  else {
}

 if (  mouseX>355 && mouseX<364 && mouseY>785 && mouseY<796) {



pointFgColRed =0;
      pointFgColGreen =0;
      pointFgColBlu =255;
    
    
  }
  else {
  }

 if (  mouseX>355 && mouseX<364 && mouseY>808 && mouseY<819) {




  

      pointFgColRed =250;
      pointFgColGreen =0;
      pointFgColBlu =0;
    
  }
  else {
  }

if (  mouseX>355 && mouseX<364 && mouseY>834 && mouseY<843) {




   
      pointFgColRed =0;
      pointFgColGreen =0;
      pointFgColBlu =0;
    
  }
  else {
  } 

//lines colors

 if (  mouseX>390 && mouseX<400 && mouseY>691 && mouseY<715) {




  

      fgColRed =75;
      fgColGreen =247;
      fgColBlu =139;
    
  }
  else {
  }



if (  mouseX>390 && mouseX<400 && mouseY>719 && mouseY<740) {




    

      fgColRed =148;
      fgColGreen =115;
      fgColBlu =255;
    
  }
  else {
  }

if (  mouseX>390 && mouseX<400 && mouseY>744 && mouseY<768) {


 fgColRed =255;
      fgColGreen =38;
      fgColBlu =150;
     
    
  }
  else {
  }

if (  mouseX>390 && mouseX<400 && mouseY>771 && mouseY<794) {


 fgColRed =0;
      fgColGreen =0;
      fgColBlu =255;


     
    
  }
  else {
  }


if (  mouseX>390 && mouseX<400 && mouseY>797 && mouseY<819) {




    

      fgColRed =255;
      fgColGreen =0;
      fgColBlu =0;
    
  }
  else {
  }


  if (  mouseX>390 && mouseX<400 && mouseY>822 && mouseY<847) {




      fgColRed =0;
      fgColGreen =0;
      fgColBlu =0;
    
  }
  else {
  }

  
  
  
  
   if (mouseX>428 && mouseX<437 && mouseY>690 && mouseY<846)
     {
       
       
         dimLinee = dimLinee+2;
         
       
       if (dimLinee>=27){dimLinee=1;}
     }
     
   
  
   if (mouseX>465 && mouseX<473 && mouseY>690 && mouseY<846)
     {
       
        soglia=soglia +44;}
        else{soglia=soglia;}
  
  if (soglia>=264) {
    soglia=20;
  }
     
     
     if (mouseX>499 && mouseX<508 && mouseY>690 && mouseY<846)
     {
       
       
       
       
          alphaStep=  alphaStep+1 ;}
          else{alphaStep  =  alphaStep;}
  
 
  if (alphaStep>=7)alphaStep=0;
  

  
   if (mouseX>535 && mouseX<544 && mouseY>690 && mouseY<846){
     
       dimPallini= dimPallini+8 ;
       
       
   }else{dimPallini= dimPallini;}
   
    if(dimPallini>= 43){dimPallini= 2;}
 

    
      
     if(mouseX>578 && mouseX<605 && mouseY>828 && mouseY<845){
       
       
         gray=0;
         wordCount=round(random(parole.length-1)) ;}
  else{parole=parole;gray=210;}

      
      
         
         if (mouseX>45 && mouseX<111 && mouseY>696 && mouseY<715){
 if(mousePressed==true){
   
   recordGo=true;
         clickCount=clickCount+1;
         
         
 }else{recordGo=false;}}
 
         }















